/*	
 *	standby3.c
 *
 *	A/DϊUSBRg[~߂X^oCEvO
 *	Copyright (C) 2002 Naoyuki Sawa
 *
 *	* Tue Oct 2 06:00:00 JST 2002 Naoyuki Sawa
 *	- 쐬JnB
 *	* Fri Oct 4 06:42:00 JST 2002 Naoyuki Sawa
 *	- ^C}R[obNĂ΂āA~߂A/DɍċNĂ܂A
 *	  dɃoĂ̂CB
 *	  ^C}R[obN~߂ɂ́A16rbg^C}0RyAB
 *	  ~߂Ȃ΂Ȃ̂ɁAOVerł͊ԈႦNMI~߂Ă܂B
 *	* Fri Oct 4 19:15:00 JST 2002 Naoyuki Sawa
 *	- USBCNbN̒~ł͎~܂肫ĂȂ݂Ȃ̂ŁA
 *	  IɎ~߂Ă݂܂B
 *	* Sat Oct 5 06:34:00 JST 2002 Naoyuki Sawa
 *	- USBڑEUSBʐM̓X^oCJnɓȂ悤ɏCB
 *	- X^oCłǂ̌ʂԂ悤ɂ܂B
 *	  ߂l̈Ӗ́ApcePowerEnterStandby()ƓłB
 */
#include <piece.h>
#include "c33209.h"
#include "d12ci.h"

int standby3();	/* A/DϊUSBRg[~߂X^oC֐ */

unsigned char vbuff[DISP_X * DISP_Y];	/* zVRAM */

/****************************************************************************
 *	
 ****************************************************************************/

void
pceAppInit()
{
	/* ʓIȏ */
	pceLCDDispStop();
	pceLCDSetBuffer(vbuff);
	pceAppSetProcPeriod(100);
	pceCPUSetSpeed(CPU_SPEED_HALF); /* X^oC̏ȓd͂̂ */
	pceLCDDispStart();

	/* ʕ\B */
	memset(vbuff, 0, sizeof vbuff);
	pceFontSetType(0x80);
	pceFontSetTxColor(3);
	pceFontSetBkColor(-1);
	pceFontSetPos(0, 0);
	/*             0123456789012345678901234 */
	pceFontPutStr("SELECT+BŻނ܂\n");
	pceFontPutStr("ADCUSBC~܂\n");
	pceFontPutStr("v͓Â܂\n");
	pceFontPutStr("\n");
	pceFontPutStr("STARTŻމ܂\n");
	pceFontPutStr("1b͖̉\n");
	pceFontPutStr("\n");
	pceFontPutStr("A{^ŏI܂\n");
}

void
pceAppProc(int count)
{
	int retval, joy;

	/* L[͎擾B */
	joy = pcePadGet();

	/* A{^ŏIB */
	if(joy & TRG_A) {
		pceAppReqExit(0);
		return;
	}

	/* SELECT+BŃX^oCB */
	if((joy & PAD_SELECT) && (joy & TRG_B)) {
		/* X^oCĂ݂B */
		retval = standby3();
		/* ʕ\B */
		pceFontSetType(0x82);
		pceFontSetTxColor(3);
		pceFontSetBkColor(0);
		pceFontSetPos(0, DISP_Y - 6);
		switch(retval) {
		case 0: pceFontPutStr("SUCCESS          "); break;
		case 1: pceFontPutStr("FAIL: USBC ACTIVE"); break;
		case 2: pceFontPutStr("FAIL: BUS POWERED"); break;
		default:pceFontPutStr("FAIL: UNKNOWN    "); break;
		}
	}

	/* d\XV̂߂ɉʓ]B */
	pceLCDTrans();
}

void
pceAppExit()
{
}

/****************************************************************************
 *	standby3 - A/DϊUSBRg[~߂X^oC
 *		   ߂l̈Ӗ́ApcePowerEnterStandby()Ɠ
 ****************************************************************************/

/* USBRg[~A/Dϊ~X^oCA/Dϊ한USBRg[ */
int
standby3()
{
	int result;
	unsigned char save_bINT_E16T01_E16TU0;

	/******************** USBRg[~ ********************/

	/* * USBʐMUSBRg[~Ă܂Ȃ悤AX^oCیs܂B
	 *   pcePowerEnterStandby()ŏɂĂ̂ƓłB
	 * uUSBʐMvƏ܂Af[^̂Ƃ肾USBʐMł͂܂I
	 *   zXgƂ̃t[Ȃǂ̐pPbĝƂASuUSBʐMvłB
	 *   ܂AUSBP[uhĂ΁AقڂłuUSBʐMvłA
	 *   USBP[uhĂԁAUSBCX^oCԂɂȂ邱Ƃ́A܂AȂ悤łB
	 */
	if(!bK5_K5D_K50D) return 1;	/* USBRg[ʐMȂ̂ŁAX^oCł܂ */
					/* iʐMƂƂUSBڑĂ͂Ȃ̂ŁǍł͂͂B  */
					/*   ͖̌ӖȂ̂łApcePowerEnterStandby()ɕČĂ݂܂B */
	if(!bP2_P2D_P22D) return 2;	/* USBdɂ쓮Ȃ̂ŁAX^oC͖Ӗł   */

	/* * USBCɃNbN~߂ł́AUSBC~܂肫ĂȂ悤łB
	 *   J[lݒ肵ĂPEQp[^AOƓd݂łB
	 *   ɂƁAp[^Ɠd̑֌W͎̒ʂB
	 * * Ȃ̂ŁAʂȃp[^܂B
	 *   ʂȏꍇ́AƂ肠OĂ݂邱Ƃɂ܂B
	 * * ݂̃J[lZbgĂAep[^ɑ΂ʂ͎̂ƂłB
	 *   [hF
	 * 	D12_NOLAZYCLOCK		ʔBÔǂ킩ȂB
	 * 	D12_CLOCKRUNNING	O炩ɓdBOׂB
	 * 	D12_SOFTCONNECT		OƓdBOĂ͂ȂI
	 *   NbNF
	 * 	D12_SETTOONE		O_IOpceUSBReconnect()Őݒ蕜AłȂȂH
	 * 				USBCďĂt@C]łȂȂĂ܂܂B
	 * 				dʂ͂邩Ȃ킩Ȃ炢BԂAȂłB
	 * 	D12_CLOCK_4M		OƓdBOĂ͂ȂI
	 * * USBC𒼐ڑ삷ÔƂāApceUSBDisconnect()ǂł݂̂łA
	 *   ǂ炱͂Ȃ悤łBiƂƖӖł(^^:j
	 *   Ƃ̂AP/ECĚ̍ɂāApceUSBDisconnect()ĂԂpcePowerEnterStandby()
	 *   X^oCȂȂiĂjƂ݂Ȃ̂łB
	 *   \łApceUSBDisconnect()ǂSOFTCONNECTOƁA
	 *   USBRg[CPUւ̃X^oCMOFFɂȂ̂ł͂ȂƐ܂B
	 *   X^oCMOFFɂȂƁApcePowerEnterStandby()̓X^oC܂B
	 * * ́AX^oCUSBCȓd̓[hɐݒ肵Ă݂܂Aʏ퓮쎞ł悤C܂B
	 *   P/ECEJ[lAUSBCʐMUSBCNbN~܂Ȃ悤ɐݒ肵Ă闝R͂Ȃł傤H
	 *   USBC̓쎞d͌\傫i`15mAAlƓdr̂Ƃł́`30mAHĵŁA
	 *   USBCʐMɓNbN~߂΁A쎞̓d͂Ȃ茸点悤ȋĈłEEE
	 */
	/* pceUSBDisconnect()Ă񂶂Ⴞ߁I */
	D12_SetMode(D12_SOFTCONNECT/*Kv!*/, D12_SETTOONE/*Kv!*/ | D12_CLOCK_4M/*Kv!*/);

	/******************** A/Dϊ~ ********************/

	/* * pcePowerEnterStandby()ĂԑOA/DϊfBZ[uĂĂA
	 *   pcePowerEnterStandby()̒"slp"OɃ^C}荞݂ƁA
	 *   GetPowerStat()Ă΂A/Dϊ킪Cl[uĂ܂܂B
	 *   h߂ɁA^C}荞݂~ĂA/DϊfBZ[u܂B
	 * * pcePowerEnterStandby()̒ł^C}荞݂̕ۑE~EsĂ݂Ȃ̂ŁA
	 *   ۑ~{ۑ~X[v}AƓdɂȂĂ邩m܂񂪁A
	 *   Ȃ͂łB
	 */
	save_bINT_E16T01_E16TU0 = bINT_E16T01_E16TU0;	/* ݂̐ݒۑ(ONɌ܂Ă邯)           */
	bINT_E16T01_E16TU0 = 0;				/* 16rbg^C}0RyAB~                   */
	bINT_F16T01_F16TU0 = 0;				/* 16rbg^C}0RyAB荞݂mɃNA */

	/* * A/DϊfBZ[u܂B
	 *   ݂P/ECEJ[ĺAA/Dϊ荞݂̒ōČvݒ̂߂
	 *   uA/DϊfBZ[uȊÓAɃCl[uɂĂ悤łB
	 * * A/DϊfBZ[u鏇ɒӂĂI
	 *   uA/Dϊ튄荞݂֎~vĂuA/DϊfBZ[uv܂B
	 *   tɂƁAfBZ[u`荞݋֎~̊ԂA/Dϊ荞݂ꍇA
	 *   int_ISR()̒ōĂуCl[uĂ܂\܂B
	 * * S1C33209/221/222eNjJ}jA
	 *   uIV-2 A/Dϊ vO~O̒ӎ (AcrobatReaderł407y[W)v
	 *   (6)ɂƁAA/Dϊ͌vłȂĂCl[uɂȂĂ邾
	 *   dĂ邻Ȃ̂ŁAfBZ[uΏd͂łB
	 * * ƂAu8.4 d (82y[W)v(3)AiOddɂ
	 *   A/Dϊ̏d500`800uAxȂ̂ŁAP/ECȆҋ@d6mAɊrׂ
	 *   Ă΂m܂񂪁EEE
	 */
	bINT_EP47_ECT_EAD_EADE = 0;	/* A/Dϊ튄荞݋֎~           */
	bINT_FP47_FCT_FAD_FADE = 0;	/* A/Dϊ튄荞݂mɃNA */
	bAD_EN_ADE = 0;			/* A/DϊfBZ[u           */

	/******************** X^oC ********************/

	/* X^oC[hցB */
	result = pcePowerEnterStandby(0);

	/******************** A/Dϊ𕜌 ********************/

	/* * A/Dϊ𖾎IɃCl[uKv͂܂B
	 *   NMI𕜌GetPowerStat()Ă΂悤ɂȂ΁A
	 *   GetPowerStat()Ă΂start_ADC()̒ŁA
	 *   A/DϊCl[uA荞݂ONɂ邩łB
	 */

	bINT_E16T01_E16TU0 = save_bINT_E16T01_E16TU0;	/* 16rbg^C}0RyAB */

	/******************** USBRg[𕜌 ********************/

	/* * X^oCOUSBC̐ݒς̂ŁAɖ߂܂B
	 * ݒSɖ߂͂Ȃ̂ɁAȂ쎞d30mA炢ĂH
	 *   ɖȂUSBgEEEꂵǁAȂH
	 */
	pceUSBReconnect();

	return result; /* pcePowerEnterStandby()̖߂l̂܂ܕԂ܂ */
}
